#include <p32xxxx.h>
#include <plib.h>
#include "..\APP2013TM_LCM.h"

// [JTLinker Script File, {\񪺦m
// iHTftBootloaderC

#define SystemFrequency			80000000L
#define PBFrequency				SystemFrequency / 8
#define Timer1Tick				( PBFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec		10
#define Timer2Tick				( PBFrequency / 1 / T2TogglesPerSec )
#define T2TogglesPerSec			1000
#define OCPWM3Period       		Timer2Tick

void UART_PutRAMString(unsigned char * String);

unsigned int VR1Value = 0;
volatile unsigned char UART_IsReceived = 0;
volatile unsigned char UART_ReceiveBuffer = 0;
unsigned char Cursor = 12;
volatile unsigned char MyFlag1 = 0;
unsigned char UARTString1[ 0x10 ];

// إTimer1_AȨ禡AëwDn_uv4C

void __ISR(_TIMER_1_VECTOR, ipl4) ISR_Timer1(void)
{
    static unsigned int i = 0;

    // MTimer_XСC
    INTClearFlag(INT_T1);

    // ϥXC32 ConvertADC10 FunctionҰADCഫC
    ConvertADC10();

    if (++i > 4)
    {
        i = 0;
        MyFlag1 = 1;
    }

    // IO PortA(Toggle)C
    mPORTBToggleBits(BIT_13);
}

// إUART2_AȨ禡AëwDn_uv5C

void __ISR(_UART_2_VECTOR, ipl5) ISR_UART2(void)
{
    // U2E & U2TX & U2RX @ΦVq, T{O_U2RXC
    if (INTGetFlag(INT_U2RX))
    {
        // ϥXC32 UART FunctionŪ쪺(JܼUART_ReceiveBuffer)C
        // `N : Bƶ²ϥγ@ܼxsAYyqjɡA
        //        zLLnUAHKƿ򥢡A
        //        Ҧp:إߤ@Data QueueӦs񦬨쪺ơC
        UART_ReceiveBuffer = UARTGetDataByte(UART2);

        // To Do : MU2RX_XСC
        INTClearFlag(INT_U2RX);

		UART_IsReceived = 1;
    }

        // `AU, ӶiJB, YiJB, NUARTDw_o͡C
    else
    {
        while (1);
    }
}

void main(void)
{
    // Disable the JTAG function
    DDPCONbits.JTAGEN = 0;

    // ϥXC32OSCConfig FunctionA
    // ʺAMCUtήɯ߬Primary Oscillator With PLL (80MHz)C
    OSCConfig(OSC_POSC_PLL, OSC_PLL_MULT_20, OSC_PLL_POST_1, 0);

    // ϥXC32OSCSetPBDIV FunctionA
    // ʺASystem ClockPB Clockv1:8C
    OSCSetPBDIV(OSC_PB_DIV_8);

    // ϥXC32SYSTEM ConfigƱNWait StatePPrefetch̨ΤơC
    SYSTEMConfig(SystemFrequency, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);

    // ϥXC32 I/O Prot FunctionNLEDI/O]wƦXAëwI/O PortAC
    mPORTBSetPinsDigitalOut(BIT_13); // D5
    mPORTBClearBits(BIT_13);

    // ϥXC32 OpenTimer1 Function ]wTimer1C
    OpenTimer1(T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT, Timer1Tick);

    // ϥXC32 ConfigIntTimer1 FunctionҥTimer1_
    // ëwDn_uv4Anuv0C
    ConfigIntTimer1(T1_INT_ON | T1_INT_PRIOR_4 | T1_INT_SUB_PRIOR_0);

    // ϥXC32 OpenADC10 Function]wADCC
    OpenADC10(ADC_MODULE_ON | ADC_IDLE_CONTINUE | ADC_FORMAT_INTG16 | ADC_CLK_MANUAL | ADC_AUTO_SAMPLING_ON | ADC_SAMP_OFF,
              ADC_VREF_AVDD_AVSS | ADC_OFFSET_CAL_DISABLE | ADC_SCAN_OFF | ADC_SAMPLES_PER_INT_1 | ADC_ALT_BUF_OFF | ADC_ALT_INPUT_OFF,
              ADC_SAMPLE_TIME_31 | ADC_CONV_CLK_SYSTEM | ADC_CONV_CLK_32Tcy,
              ENABLE_AN11_ANA, SKIP_SCAN_ALL);

    //  ϥXC32 SetChanADC10 Function]wADT,tqD( (+)AN11 , (-)VREF- )C
    SetChanADC10(ADC_CH0_POS_SAMPLEA_AN11 | ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEB_AN0 | ADC_CH0_NEG_SAMPLEB_NVREF);
    // *MPLAB XC v1.21e(t), ADC_CHx_POS_SAMPLEx_ANxx, ADC_CHx_NEG_SAMPLEx_xxxxx ثeu䴩 AN0 - AN15,
    // AN16ثegȦs.
    // Example : AD1CHS = 0x001A0000; //AN26,VREFL,AN0,VREFL

    // ϥXC32 PPS Function]wU2RX, U2TXC
    PPSUnLock;
    PPSOutput(2, RPF0, U2TX); //Assign U2TX
    PPSInput(1, U2RX, RPF1); //Assign U2RX
    PPSLock;

    // ϥXC32 UART Function]wUART ( 19200 , N , 8 , 1 )C
    UARTConfigure(UART2, UART_ENABLE_PINS_TX_RX_ONLY);
    UARTSetFifoMode(UART2, UART_INTERRUPT_ON_TX_NOT_FULL | UART_INTERRUPT_ON_RX_NOT_EMPTY);
    UARTSetLineControl(UART2, UART_DATA_SIZE_8_BITS | UART_PARITY_NONE | UART_STOP_BITS_1);
    UARTSetDataRate(UART2, PBFrequency, 19200);
    UARTEnable(UART2, UART_ENABLE | UART_PERIPHERAL | UART_TX | UART_RX);

    // ϥXC32 Interrupt Function]wUART Interrupt U2RX enable, U2TX DisableC
    // ëwDn_uv5Anuv0C
    INTSetVectorPriority(INT_UART_2_VECTOR, INT_PRIORITY_LEVEL_5);
    INTSetVectorSubPriority(INT_UART_2_VECTOR, INT_SUB_PRIORITY_LEVEL_0);
    INTEnable(INT_U2RX, INT_ENABLED);

    // To Do : ϥXC32 PPS Function]wOC3C
    ANSELBbits.ANSB10 = 0;
    PPSUnLock;
    PPSOutput(1, RP????, OC????); //Assign OC3
    PPSLock;

    // To Do : ϥXC32 Timer Functioni]w, @OC3Time BaseC
    OpenTimer2(T2_ON | T2_IDLE_CON | T2_GATE_OFF | T2_PS_1_???? | T2_SOURCE_INT, ????);

    // To Do : ϥXC32 OC Functioni]wC
    OpenOC3(OC_ON | OC_IDLE_CON | OC_TIMER_MODE16 | OC_TIMER????_SRC | OC_PWM_FAULT_PIN_DISABLE,
            ????, ????);

    // ϥXC32 INTEnableSystemMultiVectoredInt Function
    // ]wPIC32h_VqҦC
    INTEnableSystemMultiVectoredInt();

    // LCMlơC
    LCM_Init();

    // ]wCСAXrC
    LCM_SetCursor(0, 0);
    LCM_PutROMString((unsigned char *) "PIC32MX450F256H ");
    LCM_SetCursor(0, 1);
    LCM_PutROMString((unsigned char *) "VR1:    ,RX:    ");

    while (1)
    {
        // P_ADC1_XСC
        if (INTGetFlag(INT_AD1))
        {
            // TMADC1_X
            INTClearFlag(INT_AD1);

            // ADC Buffer 0ŪADCഫƭȡC
            VR1Value = (unsigned int) ReadADC10(0);

            // ]wCСAXADCƭȡC
            LCM_SetCursor(4, 1);
            LCM_PutNumber(VR1Value, 4);

            // ϥXC32 OC Function]wPWM DutyC
            if (VR1Value >= 1023)
                SetDCOC3PWM(OCPWM3Period + 1);

            else
                SetDCOC3PWM(((long) VR1Value * OCPWM3Period) / 1023);
        }

        // P_UART2O_
        if (UART_IsReceived)
        {
            UART_IsReceived = 0;

            // ]wCСAXrC
            LCM_SetCursor(Cursor++, 1);
            LCM_PutASCII(UART_ReceiveBuffer);

            if (Cursor > 15) Cursor = 12;
        }

        if (MyFlag1)
        {
            MyFlag1 = 0;
            sprintf((char *) UARTString1, "AD Value : %4d, OC3RS(Duty):%d, PR2(Period):%d \r\n",
                    VR1Value, OC3RS, PR2);

            // ϥΦۭqƱNrzLUARTXC
            UART_PutRAMString(UARTString1);
        }
    }

    while (1);
}

void UART_PutRAMString(unsigned char * String)
{
    while (*String != 0x00)
    {
        while (!UARTTransmitterIsReady(UART2));
        UARTSendDataByte(UART2, *String++);
    }
}
