#include <p32xxxx.h>
#include <plib.h>

// [JTLinker Script File, {\񪺦m
// iHTftBootloaderC

#define SystemFrequency			80000000L
#define PBFrequency				SystemFrequency / 8
#define Timer2Tick				( PBFrequency / 256 / Timer2TogglesPerSec )
#define Timer2TogglesPerSec		10
#define Timer3Tick				( PBFrequency / 256 / Timer3TogglesPerSec )
#define Timer3TogglesPerSec		1
#define Timer4Tick				( PBFrequency / 256 / Timer4TogglesPerSec )
#define Timer4TogglesPerSec		2
#define Timer5Tick1				( PBFrequency / 256 / Timer5TogglesPerSec1 )
#define Timer5TogglesPerSec1	10
#define Timer5Tick2				( PBFrequency / 256 / Timer5TogglesPerSec2 )
#define Timer5TogglesPerSec2	2

void main(void)
{
    // Disable the JTAG function
    DDPCONbits.JTAGEN = 0;

    // ϥXC32OSCConfig FunctionA
    // ʺAMCUtήɯ߬Primary Oscillator With PLL (80MHz)C
    OSCConfig(OSC_POSC_PLL, OSC_PLL_MULT_20, OSC_PLL_POST_1, 0);

    // ϥXC32OSCSetPBDIV FunctionA
    // ʺASystem ClockPB Clockv1:8C
    OSCSetPBDIV(OSC_PB_DIV_8);

    // ϥXC32SYSTEM ConfigƱNWait StatePPrefetch̨ΤơC
    SYSTEMConfig(SystemFrequency, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);

    // ϥXC32 I/O Prot FunctionNLEDI/O]wƦXAëwI/O PortAC
    mPORTBSetPinsDigitalOut(BIT_9 | BIT_10 | BIT_12 | BIT_13); // D2, D3, D4, D5
    mPORTBClearBits(BIT_9 | BIT_10 | BIT_12 | BIT_13);

    // ϥXC32 OpenTimer2 Function ]wTimer2C
    OpenTimer2(T2_ON | T2_IDLE_CON | T1_GATE_OFF | T2_PS_1_256 |
               T2_SOURCE_INT, Timer2Tick);

    // ϥXC32 OpenTimer3 Function ]wTimer3C
    OpenTimer3(T3_ON | T3_IDLE_CON | T3_GATE_OFF | T3_PS_1_256 |
               T3_SOURCE_INT, Timer3Tick);

    // ϥXC32 OpenTimer4 Function ]wTimer4C
    OpenTimer4(T4_ON | T4_IDLE_CON | T4_GATE_OFF | T4_PS_1_256 |
               T4_SOURCE_INT, Timer4Tick);

    // ϥXC32 OpenTimer5 Function ]wTimer5C
    OpenTimer5(T5_ON | T5_IDLE_CON | T5_GATE_OFF | T5_PS_1_256 |
               T5_SOURCE_INT, Timer5Tick1);

    while (1)
    {
        //P_Timer2_XСC
        if (INTGetFlag(INT_T2))
        {
            static unsigned int i = 0;

            // MTimer2_XСC
            INTClearFlag(INT_T2);

            if (++i > 19)
            {
                i = 0;
                // IO PortA(Toggle)C
                mPORTBToggleBits(BIT_9);
            }
        }

        //P_Timer3_XСC
        if (INTGetFlag(INT_T3))
        {
            // MTimer3_XСC
            INTClearFlag(INT_T3);

            // IO PortA(Toggle)C
            mPORTBToggleBits(BIT_10);
        }

        //P_Timer4_XСC
        if (INTGetFlag(INT_T4))
        {
            // MTimer4_XСC
            INTClearFlag(INT_T4);

            // IO PortA(Toggle)C
            mPORTBToggleBits(BIT_12);
        }

        //P_Timer5_XСC
        if (INTGetFlag(INT_T5))
        {
            static unsigned int i = 0;

            // MTimer5_XСC
            INTClearFlag(INT_T5);

            /*
                        if (!i)
                        {
                            OpenTimer5(T5_ON | T5_IDLE_CON | T5_GATE_OFF | T5_PS_1_256 |
                                                            T5_SOURCE_INT, Timer5Tick2);
                            i = 1;
                        }

                        else
                        {
                            OpenTimer5(T5_ON | T5_IDLE_CON | T5_GATE_OFF | T5_PS_1_256 |
                                                            T5_SOURCE_INT, Timer5Tick1);
                            i = 0;
                        }


                        // IO PortA(Toggle)C
                            mPORTBToggleBits(BIT_13);
             */

            switch (++i)
            {
            case 1:
                mPORTBSetBits(BIT_13);
                break;

            case 6:
                mPORTBClearBits(BIT_13);
                i = 0;
                break;

            default:
                break;
            }
        }
    }

    while (1);
}
